/* -*- Mode:C++; -*- */

// covering.h

#ifndef __COVERING_H
#define __COVERING_H

#include "rig_maxdet.h"

int compute_F_entry
(
 const int dim,
 const int* basis,
 const int basis_index,
 const int* simplex,
 const int simplex_index,
 const int row,
 const int col
 );

void setup_maxdet_covering_constraints 
(
 const int dim,
 const int simplex_count,
 const int* simplex,
 const int basis_count,
 const int* basis,
 const int inequality_count,
 const int* inequality,
 maxdet_data& md
 );

void setup_maxdet_covering_cost_func 
(
 const int dim,
 const int basis_count,
 const int* basis,
 maxdet_data& md
 );

void setup_maxdet_packing_covering_cost_func 
(
 const int dim,
 const int basis_count,
 maxdet_data& md
 );

void free_maxdet_covering_data
(
 maxdet_data& md
 );

#endif
