/* -*- Mode:C++; -*- */

// interior_point.h

#ifndef __INTERIOR_POINT_H
#define __INTERIOR_POINT_H

// 
// returns true and writes solution of system 
//    sum_j=1^dim inequality[i*dim + j] x_j > 0 , i=1..inequality_count
// into interior if one exists, returns false otherwise
//


bool compute_interior_point 
(
 const int dim,
 const int inequality_count, 
 const int* inequality,      // array of size dim*inequality_count
 double* interior            // array of size dim 
 ); 

//
// sometimes it is useful to have a relative interior point on a facet
//

bool compute_relative_interior_point_in_facet
(
 const int dim,
 const int inequality_count,
 const int* inequality,
 const int facet_index,      // index of facet in which interior shall be 
 double* interior
 );

#endif //__INTERIOR_POINT_H


