/* -*- Mode:C++; -*- */

// mini_rmd.cc

//#include <math.h>       
#include <iostream>
#include <NTL/vec_ZZ.h>

#include "QQ.h"
#include "rig_maxdet.h"

#define COUT_PRECISION 10

void die_mini_rmd(char* last_words)
{
  std::cout <<last_words;
  exit(EXIT_FAILURE);
}


// ================
// === mini_rmd ===
// ================

int main()
{
  std::cout <<"****************\n";
  std::cout <<"*** mini_rmd ***\n";
  std::cout <<"****************\n\n";

  // 1. read input  
  maxdet_data md; 
  std::cin >> md.m;
  std::cin >> md.L;
  md.F_blkszs = (int*) calloc(md.L, sizeof(int));
  if (md.F_blkszs == NULL) die_mini_rmd("md.F_blkszs == NULL.\n");
  for (int i=0; i<md.L; i++)  
    std::cin >> md.F_blkszs[i];
  std::cin >> md.F;
  std::cin >> md.K;
  md.G_blkszs = (int*) calloc(md.K, sizeof(int));
  if (md.G_blkszs == NULL) die_mini_rmd("md.G_blkszs == NULL.\n");
  for (int i=0; i<md.K; i++)  
    std::cin >> md.G_blkszs[i];
  std::cin >> md.G;
  std::cin >> md.c;

  double* interior;
  interior = (double*) calloc(md.m, sizeof(double));
  if (interior == NULL) die_mini_rmd ("interior == NULL.\n");
  for (int i = 0; i < md.m; i++)
    std::cin >>interior[i];

  int max_iterations;
  std::cin >>max_iterations;

  double duality_gap;
  std::cin >>duality_gap;

  // 2. solve MAXDET rigorously
  NTL::vec_ZZ minimizer_approx;
  NTL::vec_ZZ dual_Z_approx;       
  NTL::vec_ZZ dual_W_approx;       
  maxdet_bound lower_bound;
  maxdet_bound upper_bound;

  solve_maxdet_rigorously(md, interior, duality_gap, max_iterations, minimizer_approx, dual_Z_approx, dual_W_approx, lower_bound, upper_bound, OUTPUT_LEVEL_ALL); 
 
  // 3. cleaning
  free(interior);

  return 0;
}
